//PROGRAMM FOR rs232 communication
//
// PROCESSOR : PIC12F629
// CLOCK	 : 4MHz, EXTERNAL
// SPEED     : 9600 bps(1bit=104us)

// NOTICE!!! 	The delays are software realized. 
//				When compile this code, please enable assembler optimization (level 9)!!!

#include	<pic.h>

__CONFIG(WDTDIS & MCLRDIS & BORDIS & XT & PWRTEN) ;
  

#define bitset(var,bitno) ((var) |= 1 << (bitno))
#define bitclr(var,bitno) ((var) &= ~(1 << (bitno)))

//Hardware port definitions
//-------------------------------------------------------------------

#define		RXIN		GPIO1		//receiv input
#define		TXOUT		0			//send output(RA3)
#define		DEAD_TIME	100

//Constant definitions
//---------------------------------------------------------------------
#define		time_out		40	//*5us

//Variables definitions
//---------------------------------------------------------------------
 unsigned char pbv;
 unsigned char data;


//Functions definitions
//-------------------------------------------------------------------

void Delay(unsigned char cntr)		//delay time = 4*(cntr-1)+10 
{
	while (--cntr != 0)
		;
}

//----------------------------------------------------------------------------------(***)
void putch(unsigned char c)
{							//
	unsigned char	bitcnt;

	bitcnt = 9;							//1 start bit, 8 data bits, none parity

	pbv=GPIO;
	bitclr(pbv,TXOUT);					// start bit 
	GPIO = pbv;		
	asm("nop");							// begin start bit	//1
	Delay(24);							// 103us

	do {	
		if(c & 1) 	
			bitset(pbv,TXOUT);			// 2us
		if (!(c & 1))	
			bitclr(pbv,TXOUT);			// 2us

		GPIO = pbv;						// 2us
		Delay(22);						// 94us
		c = (c >> 1) | 0x80;			// 2us

	} while(--bitcnt);					// 3us
}

//----------------------------------------------------------------------------------(***)
char getch(void)
{
	unsigned char	c, bitcnt;

	for(;;) {

		while(!RXIN) 					// wait for start bit 
			continue;	

		Delay(22);						// 94us

		if(!RXIN)						// it was just noise 
			continue;	

		bitcnt = 8;
		c = 0;
		do {
			Delay(23);					// 97us
			c = (c>>1)|(RXIN << 7);		// 3us
		} while(--bitcnt);				// 3us	

		// Invert 
		return ~c;
	}
}

void main( void ) {

	OPTION	= 0x80;			// GPIO pull-ups are disabled
	INTCON 	= 0x0;			// Disable inerupt
	WPU 	= 0x0;			// pull-up disable
	ANSEL 	= 0x0;			// port as Digital IO

	GPIO   = 0x01;		    // Set TX ti high
	CMCON  = 0x07;			// port as Digital IO
	TRISIO = 0xFE;			// TX output, RX input	


	// loop forever - echo plus one
	while(1) {
		data = getch();     
		putch(data+1);		
	}
}
